﻿// ---------------------------------------------------------------------
/*
 * Copyright 2010 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */
// ---------------------------------------------------------------------
#ifndef	HarkFileIOByMatrix_NH_h_defined
#define	HarkFileIOByMatrix_NH_h_defined
// ---------------------------------------------------------------------
//#include "../config.h"


#include "BF_Matrix.h"

#include <vector>

#ifdef ENABLE_HARKIO3
#else
#include "HarkFileIO.h"
#endif

class CHarkFileIOByMatrix
{
public:
	CHarkFileIOByMatrix();
	~CHarkFileIOByMatrix();
	
	// tfファイルのオープン(cFilenameが既に開いている場合はスルーする)
	bool OpenTFfile(const char* cFilename, const char* cFileType);

	// tfファイルの再オープン
	bool ReopenTFfile(const char* cFilename, const char* cFileType);
	
	// tfファイルのクローズ
	bool CloseTFfile();
	
	// ファイル読み込み
	bool ReadHeader(const char* cFilename, const char* cFileType,
					long *plFs,
					long *plNFFT,
					long *plNSrc,
					long *plNMic);
	
	// TFデータを読込み
	bool ReadTFData(const char* cFilename, 
					float thresh,
					BF::TransformFunctionDatabase &sDatabase);
	
	// SPデータを読込み
	bool ReadWData(const char* cFilename, 
					BF::Database &sDatabase);

	// SPデータを書込み
	bool WriteWData(const char* cFilename, 
					long lFs,
					long lNFFT,
					BF::Database sDatabase);

	
	// メンバー
	char*	m_pcTFfilename;	///< TFファイル名
	char*	m_pcFileType;
#ifdef ENABLE_HARKIO3
	harkio_TransferFunction	*m_ptf;	///< TFファイルポインタ
#else
	CHarkFileIO	m_ctf;
#endif
	
private:
	void _CalcNeighbors(std::vector<BF::SourceLocation> sourceLocations, float thresh, std::vector<std::vector<int> > &viNbrs);
};
#endif
