#pragma once

#ifndef ___STRDURLOG_HPP___
#define ___STRDURLOG_HPP___


#include <string>
#include <chrono>
#include <sstream>
#include <iostream>
#include <iomanip>

using namespace std;

static std::string DurationLog(const std::chrono::nanoseconds dt){

  std::chrono::microseconds dus = std::chrono::duration_cast<std::chrono::microseconds>(dt);
  std::chrono::seconds dsec = std::chrono::duration_cast<std::chrono::seconds>(dus);
  std::chrono::minutes dmin = std::chrono::duration_cast<std::chrono::minutes>(dus);
  std::chrono::hours dhour = std::chrono::duration_cast<std::chrono::hours>(dus);

  int ihour,imin,isec;
  unsigned ius;

  ihour = dhour.count();
  imin = dmin.count() - dhour.count() * 60;
  isec = dsec.count() - dmin.count() * 60;
  ius = dus.count() - dsec.count() * 1e6;

   string strLog;
   std::ostringstream sout;

   sout        << std::setfill('0') << std::setw(2) << ihour
        << ":" << std::setfill('0') << std::setw(2) << imin
        << ":" << std::setfill('0') << std::setw(2) << isec
        << "." << std::setfill('0') << std::setw(6) << ius;

    strLog = sout.str();
    return strLog;
}

#endif