/*
 * Copyright 2008 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "Particle.h"


#ifndef M_PI
#define M_PI       3.14159265358979323846
#endif


static int group_number = 0;

//***************************************************************************//
void check_source(const int flag, int Pnum, particle_group_set *pg_set, observation_set *ob_set, robot_observation_set *r_set, const PARAM s_param)   
{

  	int i, j, k;
	//FILE *fp_s;

	int *group_used;
	int *ob_used;
	double *lh_value;
	double *lh_max_ob;
	int group_rest;
	int ob_rest;

	int *group_used_r;
	int *ob_used_r;
	double *lh_value_r;
	double *lh_max_r_ob;
	int group_rest_r;
	int ob_rest_r ;

	int new_group_num;

	int pgnum;

	const double th_likelihood = s_param.m_param_th_another_source;
	const double th_ignore_source = s_param.m_param_th_ignore_source;

	pgnum = 0;ob_rest = 0;ob_rest_r = 0;

	//pg_set用の領域を確保(room)
	new_group_num = pg_set->pg_alive_num + ob_rest;
	group_used = (int*)calloc(pg_set->pg_num, sizeof(int));
	ob_used = (int*)calloc(ob_set->ob_num, sizeof(int));
	lh_value   = (double*)calloc((pg_set->pg_num)  * (ob_set->ob_num), sizeof(double));
	lh_max_ob = (double*)calloc(ob_set->ob_num, sizeof(double));

		// 対応付されてないグループの数
	group_rest = pg_set->pg_num;
		// 対応付されてない観測値の数
	ob_rest = ob_set->ob_num;

	//pg_set用の領域を確保(rob)
	new_group_num = pg_set->pg_alive_num + ob_rest_r;
	group_used_r = (int*)calloc(pg_set->pg_num, sizeof(int));
	ob_used_r = (int*)calloc(r_set->ob_num, sizeof(int));
	lh_value_r = (double*)calloc((pg_set->pg_num) * (r_set->ob_num), sizeof(double));
	lh_max_r_ob = (double*)calloc(r_set->ob_num, sizeof(double));
	group_rest_r = pg_set->pg_num;
	ob_rest_r = r_set->ob_num;

	if( pg_set->pg_alive_num > 0 ){
		pgnum = Pnum/pg_set->pg_alive_num;
	}



//-----------------//roomデータが来た場合のcheck source--------------------------------------//	
	//if(flag == ROOM_DATA || flag == ROBOT_ROOM_DATA)
	//{
	//	// 初期化
	//	for( i = 0; i < ob_set->ob_num; i++ )
	//	{
	//		lh_max_ob[i] = 0;
	//		ob_used[i] = 0;
	//	}
	//	for( i = 0; i < pg_set->pg_num; i++ )
	//	{
	//		group_used[i] = 0;

	//		for(j = 0; j < ob_set->ob_num; j++)
	//		lh_value[i * ob_set->ob_num + j] = 0; 
	//	}

	//	//各粒子グループの観測値に対する尤度の重み付き和。
	//	// グループごとに
	//	for (i = 0; i < pg_set->pg_num; i++)
	//	{
	//		if( pg_set->pg[i].pg_status == PG_STATUS_ALIVE )
	//		{
	//			// 観測値ごとに
	//			for(j = 0; j < ob_set->ob_num; j++)
	//			{
	//				// 各グループ中のパーティクル
	//				for(k = 0; k < pgnum; k++)
	//				{
	//					//尤度の重み付き和を記憶
	//					lh_value[i * ob_set->ob_num + j] += pg_set->pg[i].weight[k] * likelihood(&(pg_set->pg[i].state[k]), &(ob_set->ob[j]), NULL, s_param);
	//				}
	//				// 一番高い尤度を求める(新しい音源を作るかどうかの前準備) 
	//				if (lh_value[i*ob_set->ob_num + j] > lh_max_ob[j])
	//				{
	//					lh_max_ob[j] = lh_value[i*ob_set->ob_num + j];
	//				}
	//			}
	//		} else 
	//		{
	//			// PG_STATUS_DEAD なら使ったことにする
	//			group_used[i] = 1;
	//		}
	//	}
	////	printf("group_rest:%d ob_rest: %d\n",group_rest, ob_rest);	//PGと観測値を対応付ける前の個数

	//	//尤度が高いものから順に用いる。
	//	while( group_rest > 0 && ob_rest > 0 )
	//	{
	//		int near_g = 0, near_o = 0;
	//		double lh = 0;
	//	//最尤なものを探す。(ob_setやpg_setは少ないので、ひとまず線形に探索)
	//		for( i = 0; i < pg_set->pg_num; i++ )
	//		{
	//			if( group_used[i] == 0 )
	//			{
	//				for(j = 0; j < ob_set->ob_num; j++ )
	//				{
	//					if( ob_used[j] == 0)
	//					{
	//						if( lh <= lh_value[i * ob_set->ob_num + j] )
	//						{
	//							lh = lh_value[i * ob_set->ob_num + j];
	//							near_g = i;
	//							near_o = j;
	//						}
	//					}
	//				}
	//			}
	//		}
	//	//printf("lh:%f(%f) group %d ob id %d\n",lh, th_likelihood, near_g, near_o);

	//	// 最尤なものの尤度があまりにも小さければグループを増減するためにループを抜ける。
	//		if( lh < th_likelihood )
	//		{
	//			break;
	//		} else 
	//		{
	//			//最尤なものをターゲットに設定
	//			pg_set->pg[near_g].target = near_o;
	//			//もう一度使われないようにする
	//			ob_used[near_o] = 1;
	//			group_used[near_g] = 1;
	//			group_rest--;
	//			ob_rest--;
	//		}
	//	}

	//	// 近接した部分に新しいグループが出来ないように, 他の粒子グループでカバーされている観測結果は無視。
	//	for (i=0; i<ob_set->ob_num; i++)
	//	{
	//		if (ob_used[i]==0 && lh_max_ob[i] > th_ignore_source)
	//		{
	//			ob_used[i] = 1;
	//			ob_rest--;
	//		}
	//	}
	//}
			
//-----------------//robデータが来た場合のcheck source--------------------------------------//	
	if(flag == ROBOT_DATA || flag == ROBOT_ROOM_DATA)
	{
		// 初期化
		for( i = 0; i < r_set->ob_num; i++ )
		{
			lh_max_r_ob[i] = 0;                                                                                                                                                                                                                                                                                                                                                                                                                                                    
			ob_used_r[i] = 0;
		}

		for( i = 0; i < pg_set->pg_num; i++ )
		{
			group_used_r[i] = 0;
			for(j = 0; j < r_set->ob_num; j++)
				lh_value_r[i * r_set->ob_num + j] = 0; 
		}


	 	for (i = 0; i<pg_set->pg_num; i++)
		{
			if( pg_set->pg[i].pg_status == PG_STATUS_ALIVE ) //1128修正
			{
				pg_set->pg[i].r_target = -1;

				for(j = 0; j < r_set->ob_num; j++)
				{
					for(k = 0; k < pgnum; k++)
					{
						//尤度の重み付き和を記憶
						lh_value_r[i*r_set->ob_num + j] += pg_set->pg[i].weight[k] * likelihood(&(pg_set->pg[i].state[k]), NULL, &(r_set->r_ob[j]), s_param);
					}
					
					// 一番高い尤度を求める(新しい音源を作るかどうかの前準備) 
					if (lh_value_r[i*r_set->ob_num + j] > lh_max_r_ob[j])
					{	
						lh_max_r_ob[j] = lh_value_r[i*r_set->ob_num + j];
						//printf("lh_max_r_ob:%f\n",lh_max_r_ob[j]);
					}
				}			
			} 
			else{
				group_used_r[i] = 1;
			}
		}

	//	printf("group_rest_r:%d ob_rest_r: %d\n",group_rest_r, ob_rest_r);	//PGと観測値を対応付ける前の個数

		//尤度が高いものから順に用いる。
		while(group_rest_r > 0 && ob_rest_r > 0)
		{
			int near_g = 0, near_o = 0;
			double lh = 0;

			//最尤なものを探す。(ob_setやpg_setは少ないので、とりあえず線形に探索)
			int i; //1028
			for (i=0; i<pg_set->pg_num; i++)
			{
				if (group_used_r[i]==0)
				{
					int j;
					for (j=0; j<r_set->ob_num; j++)
					{
						if (ob_used_r[j]==0)
						{
							if (lh <= lh_value_r[i*r_set->ob_num+j])
							{
								lh = lh_value_r[i*r_set->ob_num+j];
								near_g = i;
								near_o = j;
							}
						}
					}
				}
			}

		    // ロボットからの観測値のみの場合，最尤なものの尤度があまりにも小さければグループを増減するために
			// ループを抜ける処理を加える．
			if(flag == ROBOT_DATA)
			{
				if( lh < th_likelihood )
				{
					break;
				}

				//最尤なものをターゲットに設定
				pg_set->pg[near_g].r_target = near_o;
			
				//もう一度使われないようにする
				ob_used_r[near_o] = 1;
				group_used_r[near_g] = 1;
				group_rest_r--;
				ob_rest_r--;
			}
			else
			{	//ルームからの観測値がある場合，ロボットの観測値の方ではParticleGroupの増減には関与しない.
				//どんに尤度が小さくてもターゲットに設定

				//最尤なものをターゲットに設定
				pg_set->pg[near_g].r_target = near_o;
			
				//もう一度使われないようにする
				ob_used_r[near_o] = 1;
				group_used_r[near_g] = 1;
				group_rest_r--;
				ob_rest_r--;
			}
		}
	
		// 近接した部分に新しいグループが出来ないように, 他の粒子グループでカバーされている観測結果は無視。
		for (i = 0; i < r_set->ob_num; i++)
		{
			if (ob_used_r[i]==0 && lh_max_r_ob[i] > th_ignore_source)
			{
				ob_used_r[i] = 1;
				ob_rest_r--;
			}
		}
	}

//------------------ParticleGroupのdelete または generate-------------------------------------//			
	if(flag == ROBOT_DATA)
	{
		if (group_rest_r>0)
		{
			//粒子グループが定位結果より多い。→ ある程度の時間が経過すれば粒子グループを削除
			
			group_delete(Pnum, pg_set, group_used_r,r_set->ob_FrameID, s_param);
		}

		if (ob_rest_r>0)
		{
			//定位結果が粒子グループより多い。→ 新粒子グループを作成
			if( pg_set->pg_alive_num < s_param.m_param_max_num_of_source )
			{
//				printf("A new group is generated\n" );
				group_generate(flag, Pnum, pg_set,NULL, r_set, ob_used_r, ob_rest_r, s_param);
			}
		}
	}
	//else
	//{		
	//	if (group_rest > 0 || group_rest_r > 0)
	//	{
	//		//粒子グループが定位結果より多い。→ ある程度の時間が経過すれば粒子グループを削除
	//		group_delete(Pnum, pg_set, group_used, ob_set->ob_FrameID, s_param);
	//	}

	//	if (ob_rest > 0 || ob_rest_r > 0)
	//	{
	//		//定位結果が粒子グループより多い。→ 新粒子グループを作成
	//		if( pg_set->pg_alive_num < s_param.m_param_max_num_of_source )
	//		{
	//			printf("A new group is generated\n" );
	//			if(ob_rest_r > ob_rest)
	//			{
	//				ob_rest = ob_rest_r;
	//			}
	//			group_generate(flag, Pnum, pg_set, ob_set, r_set, ob_used, ob_rest, s_param);
	//		}
	//	}
	//}

	if(group_used != NULL) { 
		free(group_used);
		group_used = NULL; 
	}
	if(ob_used != NULL) {	
		free(ob_used);	
		ob_used = NULL; 
	}
	if(lh_value != NULL) {	
		free(lh_value);	
		lh_value = NULL; 
	}
	if(lh_max_ob != NULL) {	
		free(lh_max_ob);  
		lh_max_ob = NULL; 
	}

	if(group_used_r != NULL){
		free(group_used_r);
		group_used_r = NULL;
	}
	if(ob_used_r != NULL){
		free(ob_used_r); 
		ob_used_r = NULL;
	}
	if(lh_value_r != NULL){
		free(lh_value_r);
		lh_value_r = NULL;
	}
	if(lh_max_r_ob != NULL){
		free(lh_max_r_ob);
		lh_max_r_ob = NULL;
	}

}
  
//***************************************************************************//
void group_generate(const int flag, int Pnum, particle_group_set *pg_set, observation_set *ob_set, robot_observation_set *r_set, int *used, int rest, const PARAM s_param)
{
  //定位結果が残ったとき → 新グループを作成
//	float phi;
	float cos_phi;

	int new_group_num = pg_set->pg_alive_num + rest;
    int *rest_ob = (int*)calloc(rest, sizeof(int));

	int c = 0;
	int i, j;

	//初期化
	if(flag == ROBOT_DATA)
	{
		for (i = 0; i < r_set->ob_num; i++)
		{
			if (used[i] == 0)
			{
				rest_ob[c] = i;
				c++;
			}
		}
	}
	//else
	//{
	//	for (i = 0; i < ob_set->ob_num; i++)
	//	{
	//		if (used[i] == 0)
	//		{
	//			rest_ob[c] = i;
	//			c++;
	//		}
	//	}
	//}

	//すでにある粒子を間引く(一つのグループに割り当てる粒子数を減らす)
	for (i=0; i<pg_set->pg_num; i++)
	{
		if( pg_set->pg[i].pg_status == PG_STATUS_ALIVE )
		{
			SIR(Pnum/pg_set->pg_alive_num, Pnum/new_group_num, pg_set->pg[i].state, pg_set->pg[i].weight,  pg_set->pg[i].state, pg_set->pg[i].weight, s_param);
			pg_set->pg[i].state = (state_type*)realloc(pg_set->pg[i].state, sizeof(state_type)*(Pnum/new_group_num));
		}
	}

	//粒子グループの追加
	pg_set->pg = (particle_group*)realloc(pg_set->pg, sizeof(particle_group)*(pg_set->pg_num + rest));

	for (i = pg_set->pg_num; i < pg_set->pg_num + rest; i++)
	{
		pg_set->pg[i].pg_status = PG_STATUS_ALIVE; 
		pg_set->pg[i].state = (state_type*)malloc(sizeof(state_type)*(Pnum/new_group_num));
		pg_set->pg[i].weight = (weight_type*)malloc(sizeof(weight_type)*(Pnum/new_group_num));
		pg_set->pg[i].h = (history_data*)malloc(sizeof(history_data)*(Pnum/new_group_num));
	
		for (j=0; j<Pnum/new_group_num; j++)
		{
			//Particleの初期位置の設定(観測値そのまま)。 直後のimportance_samplingで遷移させられる
			pg_set->pg[i].state[j].v = 0;
			if(flag == ROBOT_DATA)
			{
				pg_set->pg[i].state[j].theta = r_set->r_ob[rest_ob[i-(pg_set->pg_num)]].theta;
				pg_set->pg[i].state[j].phi = r_set->r_ob[rest_ob[i-(pg_set->pg_num)]].phi;

				//座標は，角度から算出
				/* 使用しなていない 使用用途はデバッグ出力時に座標がほしい時くらいか
				cos_phi = cos(pg_set->pg[i].state[j].phi);
				pg_set->pg[i].state[j].x = cos((pg_set->pg[i].state[j].theta) * M_PI / 180.0f) * cos_phi;
				pg_set->pg[i].state[j].y = sin((pg_set->pg[i].state[j].theta) * M_PI / 180.0f) * cos_phi;
				pg_set->pg[i].state[j].z = sin((pg_set->pg[i].state[j].phi) * M_PI / 180.0f);
				pg_set->pg[i].state[j].orient = 0.0;
				*/
			}
			//else if(flag == ROOM_DATA)　// Roomデータのみ使わないので手を入れない
			//{
			//	pg_set->pg[i].state[j].orient = 0.0;
			//	pg_set->pg[i].state[j].x = ob_set->ob[rest_ob[i-(pg_set->pg_num)]].x; 
			//	pg_set->pg[i].state[j].y = ob_set->ob[rest_ob[i-(pg_set->pg_num)]].y; 
			//	pg_set->pg[i].state[j].theta = atan2(pg_set->pg[i].state[j].y,pg_set->pg[i].state[j].x) * 180.0f / M_PI; //0206	座標からの角度
			//}
			//else
			//{　//Robot＆Roomデータ。使わないので手を入れない
			//	if(ob_set->ob == NULL)
			//	{
			//		pg_set->pg[i].state[j].theta = r_set->r_ob[rest_ob[i-(pg_set->pg_num)]].theta; //1212

			//		//座標は，角度から算出
			//		phi = 16.7f * M_PI /180.0f;
			//		cos_phi = cos(phi);
			//		pg_set->pg[i].state[j].x = cos((pg_set->pg[i].state[j].theta) * M_PI / 180.0f) * cos(phi);
			//		pg_set->pg[i].state[j].y = sin((pg_set->pg[i].state[j].theta) * M_PI / 180.0f) * cos(phi);
			//		pg_set->pg[i].state[j].orient = 0.0;
			//	}
			//	else if(r_set->r_ob == NULL)
			//	{
			//		pg_set->pg[i].state[j].orient = 0.0;
			//		pg_set->pg[i].state[j].x = ob_set->ob[rest_ob[i-(pg_set->pg_num)]].x; 
			//		pg_set->pg[i].state[j].y = ob_set->ob[rest_ob[i-(pg_set->pg_num)]].y; 
			//		pg_set->pg[i].state[j].theta = atan2(pg_set->pg[i].state[j].y,pg_set->pg[i].state[j].x); //0206	座標からの角度
			//	}
			//	else
			//	{
			//		pg_set->pg[i].state[j].theta = r_set->r_ob[rest_ob[i-(pg_set->pg_num)]].theta;  //rob観測値そのまま
			//		
			//		pg_set->pg[i].state[j].orient = 0.0;
			//		pg_set->pg[i].state[j].x = ob_set->ob[rest_ob[i-(pg_set->pg_num)]].x;	//room観測値そのまま
			//		pg_set->pg[i].state[j].y = ob_set->ob[rest_ob[i-(pg_set->pg_num)]].y; 
			//
			//	}
			//}
			
			pg_set->pg[i].weight[j] = 1.0 / (Pnum/new_group_num);
		}	//end for

		if(flag == ROBOT_DATA)	
		{
			pg_set->pg[i].target = -1;	//1217
			pg_set->pg[i].update_FrameID = r_set->ob_FrameID;	
			pg_set->pg[i].r_target = rest_ob[i-(pg_set->pg_num)];
//			printf("GENERATE r_target= %d\n", pg_set->pg[i].r_target);
		}
	/*	else if(flag == ROOM_DATA)
		{
			pg_set->pg[i].target = rest_ob[i-(pg_set->pg_num)];
			pg_set->pg[i].update_FrameID = ob_set->ob_FrameID;	
			pg_set->pg[i].r_target = -1;
		}
		else if(flag == ROBOT_ROOM_DATA)	
		{
			if(ob_set->ob == NULL)
			{
				pg_set->pg[i].target = -1;
				pg_set->pg[i].update_FrameID = r_set->ob_FrameID;
				pg_set->pg[i].r_target = rest_ob[i-(pg_set->pg_num)];
			}
			else if(r_set->r_ob == NULL)
			{
				pg_set->pg[i].target = rest_ob[i-(pg_set->pg_num)];
				pg_set->pg[i].update_FrameID = ob_set->ob_FrameID;	
				pg_set->pg[i].r_target = -1;
			}
			else
			{
				pg_set->pg[i].target = rest_ob[i-(pg_set->pg_num)];
				pg_set->pg[i].update_FrameID = ob_set->ob_FrameID;
				pg_set->pg[i].r_target = rest_ob[i-(pg_set->pg_num)];
			}
		}*/
	
		//group_numberの初期化
		if(i == 0)
		{
			init_group_num();
		}
    
		pg_set->pg[i].index = group_number;  //作ったばかりのPGに番号をつける(#0から)
//		printf("group_num:%d\n",group_number);	
		group_number++;	
	}
	pg_set->pg_num += rest;
	pg_set->pg_alive_num += rest;
	
	if(rest_ob)
	{
		free(rest_ob);
		rest_ob = NULL;
	}
}
//***************************************************************************//
double likelihood(const state_type *state, const observation_type *ob, const robot_observation_type *r_ob, const PARAM s_param )
{
  //state(粒子一個が持つデータ)に対するobの尤度を返す。
	// 実際はRobotしか使用していない

	double R = s_param.m_param_likelihood_sigma;
	double R2 = s_param.m_param_likelihood_sigma_robot;
	double robot_weight = s_param.m_param_likelihood_robot_weight;

	double robot_theta;
	double robot_phi;
	double _phi;
	double _theta;

	double diff_theta;
	double diff_phi;
  
	double lik_room, lik_robot;

	// Robotのみしか使わないので拡張しない
	/*
	if (ob==NULL)
	{
		lik_room = 0;
	}else
	{
		lik_room = (1.0 - robot_weight) * exp(-0.5 * ((state->x-ob->x)*(state->x-ob->x) + (state->y-ob->y)*(state->y-ob->y)) / R);	//式(18)
	}
	*/

	// Robotの場合は3次元対応する
	if (r_ob==NULL)
	{
		lik_robot = 0;
	}else
	{
		// 2017.2.15 角度差分の計算方法を変更
		double diff_angle;
		state_type r_ob_tmp;
		r_ob_tmp.theta = r_ob->theta;
		r_ob_tmp.phi = r_ob->phi;
		diff_angle = state_diff_angle(*state, r_ob_tmp); //Particle Groupと書くParticleの角度を求める関数を利用
		//printf("angle = %f,%f,%f,%f,%f\n",state->theta,r_ob->theta,state->phi,r_ob->phi,diff_angle);
		lik_robot = exp(-0.5 * diff_angle * diff_angle / R2) * robot_weight ;	//式(17)
		
		/*
		_theta = state->theta; //PGの角度  1029 追加
		_phi = state->phi; //PGの角度  2016.9.18追加
		if (_theta < 0)
		{
			_theta += 360;
		}
		// 2016.9.18追加
		if (_phi < 0)
		{
			_phi += 360;
		}

		robot_theta = r_ob->theta;	//観測値データ（角度）
		diff_theta = fabs(_theta - robot_theta);

		if (diff_theta>180)
		{
			diff_theta = 360 - diff_theta;
		}

		// 2016.9.18追加
		robot_phi = r_ob->phi;	//観測値データ（角度）
		diff_phi = fabs(_phi - robot_phi);

		if (diff_phi > 180)
		{
			diff_phi = 360 - diff_phi;
		}
		
		lik_robot = exp((-0.5 * diff_theta * diff_theta + -0.5 * diff_phi * diff_phi) / R2) * robot_weight ;	//式(17)
		*/
	}

	if (ob==NULL)
	{
		return lik_robot;
	} else if (r_ob==NULL)
	{
		return lik_room;
	} else 
	{
		return lik_room + lik_robot;	//式(19)
	}
}
//***************************************************************************//
void group_delete(int Pnum, particle_group_set *pg_set, const int *group_used, int ob_FrameID, const PARAM s_param)
{
	//追跡している粒子グループが残ったとき → 一定フレーム数が経過したら対応付けされていないグループを削除
	int th_no_signal_Frame = s_param.m_param_th_remove_source;

	int delete_num = 0;
	int i;
	int new_group_num = 0;
	int pg_num_tmp;
	pg_num_tmp = pg_set->pg_num;
	for (i=0; i<pg_set->pg_num; i++)
	{
		if (group_used[i]==0)	//ターゲットになっていないものを消去
		{
			if(pg_set->pg[i].pg_status == PG_STATUS_ALIVE)	//pg_statusがすでにDEADになっているものは無視(追加1107)
			{
				pg_set->pg[i].target = -1;
				pg_set->pg[i].r_target = -1;

				//一定フレーム数以上なら削除
				if (ob_FrameID - pg_set->pg[i].update_FrameID > th_no_signal_Frame)
				{
//					printf("group_delete\n");
					pg_set->pg[i].pg_status = PG_STATUS_DEAD;
					free(pg_set->pg[i].state);
					free(pg_set->pg[i].weight);
					free(pg_set->pg[i].h);
					delete_num++;
				}
			}
		}
	}

	new_group_num = pg_set->pg_alive_num - delete_num;

	if( delete_num > 0 )
	{
//		printf("%d groups are removed\n", delete_num );
		for (i = 0; i < pg_set->pg_num; i++)
		{
			if( pg_set->pg[i].pg_status == PG_STATUS_ALIVE )
			{
				//削除された分、一つのグループの粒子数が増える。
				pg_set->pg[i].state = (state_type*)realloc(pg_set->pg[i].state, sizeof(state_type)*(Pnum/new_group_num));
				pg_set->pg[i].weight = (weight_type*)realloc(pg_set->pg[i].weight, sizeof(weight_type)*(Pnum/new_group_num));
				//粒子を配分しなおす。
				SIR(Pnum/pg_set->pg_alive_num, Pnum/new_group_num, pg_set->pg[i].state, pg_set->pg[i].weight, pg_set->pg[i].state, pg_set->pg[i].weight, s_param);
			}
		}
		pg_set->pg_alive_num -= delete_num;
	}
}
//***************************************************************************
void importance_sampling(const int flag, int Pnum, particle_group_set *pg_set, observation_set *ob_set, robot_observation_set *r_set, const PARAM s_param)
{
  // 内部状態の更新と重要度の更新 

	int i = 0, j; //iはPGの数。jはひとつのPGの中に入っているParticleの数.
	int pgnum;
	//1201
//	FILE *fp_state;

	if( pg_set->pg_alive_num > 0 ){
		pgnum = Pnum/pg_set->pg_alive_num;
	}

	// 状態の更新 
	for (i=0; i<pg_set->pg_num; i++)
	{
		if (pg_set->pg[i].pg_status == PG_STATUS_ALIVE )
		{
			if (pg_set->pg[i].target >= 0 || pg_set->pg[i].r_target >= 0)
			{
				//printf("PG%d: rob target %d\n", i, pg_set->pg[i].r_target);  

				//tfindex 2016.9.30
				// ターゲットの観測値からtfindexを更新

				if (pg_set->pg[i].target < 0)	//robデータがないとき,ようはロボの時
				{
					pg_set->pg[i].tfindex[0] = r_set->r_ob[pg_set->pg[i].r_target].tfindex[0];
				}
				

				for (j = 0; j < pgnum; j++)
				{
					//内部状態の更新と重要度の更新

					if (pg_set->pg[i].r_target < 0)	//robデータがないときはこっち
					{
						pg_set->pg[i].state[j]  = state_update(flag, pg_set->pg[i].state[j], ob_set->ob_FrameID - pg_set->pg[i].update_FrameID, s_param);					
						pg_set->pg[i].weight[j] = weight_update(&(pg_set->pg[i].state[j]), &(ob_set->ob[pg_set->pg[i].target]), pg_set->pg[i].weight[j],  NULL, s_param);
						
					} else	if(pg_set->pg[i].target < 0)//roomデータがないときはこっち
					{
						pg_set->pg[i].state[j]  = state_update(flag, pg_set->pg[i].state[j], r_set->ob_FrameID - pg_set->pg[i].update_FrameID, s_param);
						pg_set->pg[i].weight[j]  = weight_update(&(pg_set->pg[i].state[j]), NULL,  pg_set->pg[i].weight[j], &(r_set->r_ob[pg_set->pg[i].r_target]), s_param);
						
					}
					else		//両方のデータがあるばあい
					{
						pg_set->pg[i].state[j]  = state_update(flag, pg_set->pg[i].state[j], ob_set->ob_FrameID - pg_set->pg[i].update_FrameID, s_param);
						pg_set->pg[i].weight[j]  = weight_update(&(pg_set->pg[i].state[j]), &(ob_set->ob[pg_set->pg[i].target]),  pg_set->pg[i].weight[j], &(r_set->r_ob[pg_set->pg[i].r_target]), s_param);
					}
				}
					
				//更新時刻を変更
				if(flag == ROBOT_DATA)
				{
					pg_set->pg[i].update_FrameID = r_set->ob_FrameID;
				}
				else
				{
					if(ob_set->ob == NULL)
					{
						pg_set->pg[i].update_FrameID = r_set->ob_FrameID;	
					}
					else
					{
						pg_set->pg[i].update_FrameID = ob_set->ob_FrameID;
				
					}
				}
			} else 
			{
						//ターゲットが無いものは重要度はそのままで内部状態のみ遷移
				for (j = 0; j < pgnum; j++)
				{

					if(flag == ROBOT_DATA)
					{																			
						pg_set->pg[i].state[j] = state_update(flag, pg_set->pg[i].state[j],  r_set->ob_FrameID - pg_set->pg[i].update_FrameID, s_param);
					}
					else
					{
						pg_set->pg[i].state[j] = state_update(flag, pg_set->pg[i].state[j],  ob_set->ob_FrameID - pg_set->pg[i].update_FrameID, s_param);
					}	
				}
			}
		}
	}

/*		fp_state = fopen("Particle_importance_sampling.txt", "a");
			fprintf(fp_state, "%f %f %f %f\n",ret_value.x,ret_value.y,ret_value.v,ret_value.theta );
			fclose(fp_state);
*/


  // グループごとに重要度を正規化 
	for (i = 0; i < pg_set->pg_num; i++)
	{
		double sum_w = 0;
		if (pg_set->pg[i].pg_status == PG_STATUS_ALIVE )
		{
			for (j = 0; j < pgnum; j++)
			{
				sum_w += pg_set->pg[i].weight[j];  //初期状態のうちはここは1になる。
			}
			for (j = 0; j < pgnum; j++)
			{
				pg_set->pg[i].weight[j] /= sum_w;
			}
		}
	}
}
//**************************************************************************
state_type state_update(const int flag, state_type old_state, int time_diff,  const PARAM s_param)
{
  // 内部状態遷移 
	//double th = s_param.m_param_th_random_walk;
	double R = s_param.m_param_state_update_sigma;
	//double _th;
	

	//FILE *fp_retvalue;

	state_type ret_value;
	//_th	= th * (-1); //負方向のthも追加(20090108)

	if (time_diff == 0)		//初期位置
	{
		// 2016.9.18 3D拡張
		//ret_value.x = old_state.x + old_state.v*cos(old_state.theta) + randn(0, R);
		//ret_value.y = old_state.y + old_state.v*cos(old_state.theta) + randn(0, R); //もともとが間違っている？
		//ret_value.x = old_state.x + old_state.v*cos(old_state.phi)*cos(old_state.theta) + randn(0, R); // 2016.9.18
		//ret_value.y = old_state.y + old_state.v*cos(old_state.phi)*sin(old_state.theta) + randn(0, R); // 2016.9.18
		//ret_value.z = old_state.z + old_state.v*sin(old_state.phi) + randn(0, R); // 2016.9.18
		//ret_value.v = old_state.v;
		ret_value.theta = old_state.theta;
		ret_value.phi = old_state.phi; // 2016.9.18
		
		//R *= 1.1;
	}else					
	{
		/*
		if(old_state.v > th || old_state.v < _th)
		{
			// ----- 運動方程式に基づいて遷移 -----

			// 2016.9.18 3D拡張
			//ret_value.x = old_state.x + old_state.v*cos(old_state.orient * 180 / M_PI) *time_diff + randn(0, R);	//式(13)
			//ret_value.y = old_state.y + old_state.v*sin(old_state.orient *180 / M_PI) *time_diff + randn(0, R);		//式(14)
			ret_value.x = old_state.x + old_state.v * cos(old_state.phi * 180 / M_PI) * cos(old_state.theta * 180 / M_PI) * time_diff + randn(0, R);
			ret_value.y = old_state.y + old_state.v * cos(old_state.phi * 180 / M_PI) * sin(old_state.theta * 180 / M_PI) * time_diff + randn(0, R);
			ret_value.z = old_state.z + old_state.v * sin(old_state.phi * 180 / M_PI) * time_diff + randn(0, R);

			//速度の遷移(REMAのときは角度，IRMAのときは座標を使用)
			if(flag == ROBOT_DATA)
			{
				ret_value.theta = old_state.theta + randn(0, R);	//とりあえずランダムに。
				ret_value.phi = old_state.phi + randn(0, R);	//とりあえずランダムに。
				ret_value.orient = old_state.orient;		//使わないので適当に更新
				ret_value.v = 0.1 * sqrt((old_state.theta - ret_value.theta)*(old_state.theta - ret_value.theta) + (old_state.phi - ret_value.phi)*(old_state.phi - ret_value.phi)) / time_diff + 0.9 * old_state.v + randn(0, R) ;	//式(15)を角度で計算。
				
			}
			//else if(flag == ROOM_DATA)
			//{
			//	ret_value.v 
			//		= 0.1 * sqrt((old_state.x-ret_value.x)*(old_state.x-ret_value.x)
			//		+(old_state.y-ret_value.y)*(old_state.y-ret_value.y))  / time_diff + 0.9 * old_state.v + randn(0, R);	//式(15)

			//	ret_value.orient
			//		= 0.1 * atan2(old_state.y - ret_value.y, old_state.x - ret_value.x)*180 / M_PI  + 0.9 * old_state.orient + randn(0, R);	//式(16)

			//	ret_value.theta = old_state.theta ;	//使わないので適当に更新
			//}
			//else if(flag == ROBOT_ROOM_DATA)
			//{
			//	ret_value.v 
			//		= 0.1 * sqrt((old_state.x-ret_value.x)*(old_state.x-ret_value.x)
			//		+(old_state.y-ret_value.y)*(old_state.y-ret_value.y))  / time_diff + 0.9 * old_state.v + randn(0, R);	//式(15)

			//	ret_value.theta = old_state.theta;		//使わないので適当に更新

			//	ret_value.orient =  0.1 * atan2(old_state.y - ret_value.y, old_state.x - ret_value.x)*180 / M_PI  + 0.9 * old_state.orient + randn(0, R);	//式(16)
			//}
		}
		else	
		{
			*/
			// ----- random walk ----- 
			//ret_value.x = old_state.x + randn(0, R);			//式(9)
			//ret_value.y = old_state.y + randn(0, R);			//式(10)
			//ret_value.z = old_state.z + randn(0, R);			// 2016.9.18
			//ret_value.orient = old_state.orient+ randn(0, R);	//式(12)
			ret_value.theta = old_state.theta + randn(0, R);
			ret_value.phi = old_state.phi + randn(0, R);		// 2016.9.18
			//ret_value.v = old_state.v + randn(0, R);
			//ret_value.v = 0.1 *(old_state.theta - ret_value.theta) / time_diff + 0.9 * old_state.v;// + randn(0, R) ;
			//ret_value.v = 0.1 * sqrt((old_state.x-ret_value.x)*(old_state.x-ret_value.x) +(old_state.y-ret_value.y)*(old_state.y-ret_value.y) +(old_state.z-ret_value.z)*(old_state.z-ret_value.z)) / time_diff + 0.9 * old_state.v;
			
			/*
			fp_retvalue = fopen("Particle_stateupdate.txt", "a");
			//fprintf(fp_retvalue, "%f %f %f %f\n",ret_value.x,ret_value.y,ret_value.v,ret_value.theta );
			fprintf(fp_retvalue, "random walk \n" );
			fclose(fp_retvalue);
			*/
		//}		
		//R *= 1.1;		//20100511 //??
	}
/*
		fp_retvalue = fopen("Particle_stateupdate.txt", "a");
			fprintf(fp_retvalue, "%f %f %f %f\n",ret_value.x,ret_value.y,ret_value.v,ret_value.theta );
			fclose(fp_retvalue);*/

	return ret_value;
}
//**************************************************************
double randn(double mu, double sigma)
{
  // 正規分布に従う乱数を発生 

	double r1 = 0.0;
	double r2 = 0.0;
	double ran = 0.0;

	//r1が0だとまずいので
	while(r1 == 0.0){
		r1 = 1.0 * rand() / RAND_MAX;
	}

	r2 = 1.0 * rand() / RAND_MAX;

	ran = sqrt(-2.0 * sigma * log(r1)) * sin(2.0 * M_PI * r2) + mu;

	return ran;
}
//**************************************************************
void state_output(const int flag, int Pnum, const particle_group_set *pg_set, int Frame_ID, const PARAM s_param)  
{
	int i, j;
	double th = s_param.m_param_th_output_range; //平均からth以内の距離にある粒子を使用する。
	int pgnum;

	//FILE	*fp_debug;//デバッグ
	//FILE *fp_


	if( pg_set->pg_alive_num > 0 ){
		pgnum = Pnum/pg_set->pg_alive_num;
	}

	for (i=0; i<pg_set->pg_num; i++){ // グループ数分ループ
		state_type average, output_state;
		weight_type sum_w = 0;
		//var_x = 0, var_y = 0;
		//weight_type var_z = 0; //add 2016.9.18

		if( pg_set->pg[i].pg_status == PG_STATUS_ALIVE ){
			//average.x = average.y = average.v = average.theta = 0;
			//output_state.x = output_state.y = output_state.v = output_state.theta = 0;
			//average.z = 0, 
			//average.phi = 0, average.orient = 0; //add 2016.9.18
			output_state.theta = output_state.phi = 0; //add 2016.9.18
			average.theta = average.phi = 0;


			//平均を算出
			for (j = 0; j < pgnum; j++)	{ // グループ内パーティクル数分				
				//average.x += pg_set->pg[i].state[j].x * pg_set->pg[i].weight[j];
				//average.y += pg_set->pg[i].state[j].y * pg_set->pg[i].weight[j];
				//average.z += pg_set->pg[i].state[j].z * pg_set->pg[i].weight[j];//add 2016.9.18


				//角度と速度の平均も追加（1029）
				average.theta += pg_set->pg[i].state[j].theta * pg_set->pg[i].weight[j];
				average.phi += pg_set->pg[i].state[j].phi * pg_set->pg[i].weight[j]; //add 2016.9.18
				//average.v += pg_set->pg[i].state[j].v * pg_set->pg[i].weight[j];
				//printf("state_output (%d, %d) : .theta = %f, .weight = %f \n",i,j,pg_set->pg[i].state[j].theta,pg_set->pg[i].weight[j]);	
				//printf("state_output (%d, %d) : .theta_w = %f, .phi_w = %f \n",i,j,pg_set->pg[i].state[j].theta * pg_set->pg[i].weight[j],pg_set->pg[i].state[j].phi * pg_set->pg[i].weight[j]);		
								
				
			}

			for (j=0; j< pgnum; j++){
			//平均に近いものだけで、もう一度平均を計算
				if(flag == ROBOT_DATA){
					if(state_diff_angle(average, pg_set->pg[i].state[j]) < th){
						//output_state.x += pg_set->pg[i].state[j].x * pg_set->pg[i].weight[j];
						//output_state.y += pg_set->pg[i].state[j].y * pg_set->pg[i].weight[j];
						//output_state.v += pg_set->pg[i].state[j].v * pg_set->pg[i].weight[j];
						output_state.theta += pg_set->pg[i].state[j].theta * pg_set->pg[i].weight[j];

						//add 2016.9.18
						//output_state.z += pg_set->pg[i].state[j].z * pg_set->pg[i].weight[j];
						output_state.phi += pg_set->pg[i].state[j].phi * pg_set->pg[i].weight[j];

						sum_w += pg_set->pg[i].weight[j];
					}
					//分散も一応計算 使用されていない
					//var_x += pg_set->pg[i].weight[j]*(pg_set->pg[i].state[j].x-average.x)*(pg_set->pg[i].state[j].x-average.x);
					//var_y += pg_set->pg[i].weight[j]*(pg_set->pg[i].state[j].y-average.y)*(pg_set->pg[i].state[j].y-average.y);
					
					//add 2016.9.18 使用されていない
					//var_z += pg_set->pg[i].weight[j]*(pg_set->pg[i].state[j].z-average.z)*(pg_set->pg[i].state[j].z-average.z);
				}
				//else{
				//	if (state_norm(average, pg_set->pg[i].state[j])< th){
				//		output_state.x += pg_set->pg[i].state[j].x * pg_set->pg[i].weight[j];
				//		output_state.y += pg_set->pg[i].state[j].y * pg_set->pg[i].weight[j];
				//		output_state.v += pg_set->pg[i].state[j].v * pg_set->pg[i].weight[j];
				//		output_state.theta += pg_set->pg[i].state[j].theta * pg_set->pg[i].weight[j];

				//		//add 2016.9.18
				//		output_state.z += pg_set->pg[i].state[j].z * pg_set->pg[i].weight[j];
				//		output_state.phi += pg_set->pg[i].state[j].phi * pg_set->pg[i].weight[j];


				//		sum_w += pg_set->pg[i].weight[j];
				//	}
				//	//分散も一応計算
				//	var_x += pg_set->pg[i].weight[j]*(pg_set->pg[i].state[j].x-average.x)*(pg_set->pg[i].state[j].x-average.x);
				//	var_y += pg_set->pg[i].weight[j]*(pg_set->pg[i].state[j].y-average.y)*(pg_set->pg[i].state[j].y-average.y);

				//	//add 2016.9.18
				//	var_z += pg_set->pg[i].weight[j]*(pg_set->pg[i].state[j].z-average.z)*(pg_set->pg[i].state[j].z-average.z);
				//}		
			}

			//　tfindexはimportance_samplingで更新

			// sum_w は近傍の尤度の合計なので,近傍にパーティクルがないと０に近づいて悪いことが起きる
			if (sum_w > s_param.m_param_sum_weight)	{
				// 大丈夫そうなら近傍の平均を求めて代入
				//output_state.x /= sum_w;
				//output_state.y /= sum_w;
				//output_state.v /= sum_w;
				output_state.theta /= sum_w;

				//add 2016.9.18
				//output_state.z /= sum_w;
				output_state.phi /= sum_w;

				//pg_set->pg[i].h->x = output_state.x;
				//pg_set->pg[i].h->y = output_state.y;
				pg_set->pg[i].h->Frame_ID = Frame_ID;
				//pg_set->pg[i].h->v = output_state.v;
				pg_set->pg[i].h->theta = output_state.theta;

				//add 2016.9.18
				//pg_set->pg[i].h->z = output_state.z;
				pg_set->pg[i].h->phi = output_state.phi;

	//			printf("PG_Index:%d\n",pg_set->pg[i].index);
			}
			else{
				// やばそうだったら全体の平均で代用
				//output_state.x = average.x;
				//output_state.y = average.y;
				output_state.theta = average.theta;
				//output_state.v = average.v;

				//add 2016.9.18
				//output_state.z = average.z;
				output_state.phi = average.phi;

				//pg_set->pg[i].h->x = output_state.x;
				//pg_set->pg[i].h->y = output_state.y;
				pg_set->pg[i].h->Frame_ID = Frame_ID;
				//pg_set->pg[i].h->v = output_state.v;
				pg_set->pg[i].h->phi = output_state.phi;

				//add 2016.9.18
				//pg_set->pg[i].h->z = output_state.z;
				pg_set->pg[i].h->theta = output_state.theta;


				//PGの中心の座標からthetaを計算
	//			printf("PG_Index:%d\n",pg_set->pg[i].index);
			}
			/*
			fp_debug = fopen("Particle_stateoutput.txt", "a");
			fprintf(fp_debug, "%d %f %f %f %f\n",Frame_ID,output_state.x,output_state.y,output_state.v,output_state.theta );
			fclose(fp_debug);
			*/
		}
	}
}
//*************************************************************
double state_norm(state_type s1, state_type s2)
{
	///粒子間の距離
	//return (s1.x-s2.x)*(s1.x-s2.x) + (s1.y-s2.y)*(s1.y-s2.y);
	
	// 2016.9.18
	return (s1.x-s2.x)*(s1.x-s2.x) + (s1.y-s2.y)*(s1.y-s2.y) + (s1.z-s2.z)*(s1.z-s2.z);

}
//**************************************************************
double state_diff_angle(state_type s1,state_type s2)
{
	///particleが持つ角度の平均と，自分の角度との差
	//return fabs(s1.theta - s2.theta);

	// fixed 2017.2.15
	double x1,x2,y1,y2,z1,z2,dot;
	x1 = cos(s1.phi / 180 * M_PI) * cos(s1.theta / 180 * M_PI);
	y1 = cos(s1.phi / 180 * M_PI) * sin(s1.theta / 180 * M_PI);
	z1 = sin(s1.phi / 180 * M_PI);
	x2 = cos(s2.phi / 180 * M_PI) * cos(s2.theta / 180 * M_PI);
	y2 = cos(s2.phi / 180 * M_PI) * sin(s2.theta / 180 * M_PI);
	z2 = sin(s2.phi / 180 * M_PI);

	dot = (x1 * x2) + (y1 * y2) + (z1 * z2);
	if (dot > 1.0){
		return 0.0;
	}else if(dot < -1.0){
		return 180.0;
	}
	return acos(dot) * 180.0 / M_PI;

}

void selection(int Pnum, particle_group_set *pg_set, const PARAM s_param)
{
  ///重要度の低い粒子を各グループごとに間引き。

	int i;
	int pgnum;

	if( pg_set->pg_alive_num > 0 )
		pgnum = Pnum/pg_set->pg_alive_num;

	for (i = 0; i < pg_set->pg_num; i++)
	{
		if (pg_set->pg[i].pg_status == PG_STATUS_ALIVE )
		{
			SIR( pgnum, pgnum, pg_set->pg[i].state, pg_set->pg[i].weight,pg_set->pg[i].state, pg_set->pg[i].weight, s_param);
		}
	}
}
//***************************************************************************
void SIR(int old_Pnum, int new_Pnum, const state_type *state, const weight_type *weight, state_type *new_state, weight_type *new_weight, const PARAM s_param)
{
  /// 残差サンプリング法で、old_Pnum個の粒子をnew_Pnum個に増殖/除去する 

	int i = 0;
	int push_count = 0;
	weight_type *residual = (weight_type*)malloc(sizeof(weight_type)*old_Pnum);
	weight_type *weight_buf = (weight_type*)malloc(sizeof(weight_type)*new_Pnum);
	state_type *state_buf = (state_type*)malloc(sizeof(state_type)*new_Pnum);
	int *count = (int*)calloc(old_Pnum, sizeof(int));
	int *m_index = (int*)malloc(sizeof(int)*new_Pnum);
	double sum_w;

	int rest;
	
	//まずは重要度の比に応じて、(整数個の)粒子を分配する
	for (i=0; i<old_Pnum; i++)
	{
		int push_num = (int)(new_Pnum * weight[i]);
		int j;
		for (j=0; j<push_num; j++)
		{
			state_buf[push_count] = state[i];
			count[i]++;
			m_index[push_count] = i;
			push_count++;
		}
		residual[i] = weight[i] - ((weight_type)push_num) / new_Pnum;
	}

	//残りについては、残りの確率(既に分配した分を引いた確率)に比例してランダムに分配
	rest = new_Pnum - push_count;
	if (rest>0)
	{
		int j, k;
		double *random;
		for (j=1; j<old_Pnum; j++)
		{
			residual[j] += residual[j-1];
		}
		random = (double*)malloc(sizeof(double)*(rest+1));
		random[rest] = 1;
		random[rest-1] = pow(1.0*rand()/RAND_MAX, 1.0/rest);

		for (j=rest-2; j>=0; j--)
		{
			random[j] = random[j+1] * pow(1.0*rand()/RAND_MAX, 1.0/(j+1));
		}
		k = 0;
		for (j=0; j<rest; j++)
		{
			while(random[j]*residual[old_Pnum-1]>residual[k])
			{
				k++;
			}
			state_buf[push_count] = state[k];
			m_index[push_count] = k;
			count[k]++;
			push_count++;
		}
		free(random);
	}

	sum_w = 0;
	for (i=0; i<new_Pnum; i++)
	{
		weight_buf[i] = weight[m_index[i]] / count[m_index[i]];
		sum_w += weight_buf[i];
	}
	for (i=0; i<new_Pnum; i++)
	{
		weight_buf[i] /= sum_w;
	}

	memcpy(new_state, state_buf, sizeof(state_type)*new_Pnum);
	memcpy(new_weight, weight_buf, sizeof(weight_type)*new_Pnum);

	free(state_buf);
	state_buf = NULL;
	free(residual);
	residual = NULL;
	free(weight_buf);
	weight_buf = NULL;
	free(m_index);
	m_index = NULL;
	free(count);
	count = NULL;

}

//**************************************************************
weight_type weight_update(const state_type *state,  const observation_type *ob, weight_type old_weight, const robot_observation_type *r_ob, const PARAM s_param)
{
	/// stateに対するobの尤度 
	double l = likelihood(state, ob, r_ob, s_param);

	return old_weight * l;
}
//**************************************************************
void init_group_num()
{
	group_number = 0;
}
//**************************************************************
/*	//使わなくても大丈夫かも
weight_type weight_update_no_target(const state_type *state, const double h_theta,  const observation_type *ob, weight_type old_weight, const robot_observation_type *r_ob,const  PARAM s_param)
{
		//PGがターゲットにならなくなったら，前回更新されたParticleの位置との尤度を計算して，かけ離れた位置にいるParticleには消えてもらう
	double l;
	//l = likelihood(state, ob, r_ob, s_param);

	double R = s_param.m_param_likelihood_sigma;
	double R2 = s_param.m_param_likelihood_sigma_robot;
	double robot_weight = s_param.m_param_likelihood_robot_weight;

	double particle_angle;
	double diff_angle;
  
	double lik_room, lik_robot;

	if (ob==NULL)
	{
		lik_room = 0;
	}else
	{
		lik_room = (1.0 - robot_weight) * exp(-0.5 * ((state->x-ob->x)*(state->x-ob->x) + (state->y-ob->y)*(state->y-ob->y)) / R);
	}

	if (r_ob==NULL)
	{
		lik_robot = 0;
	}else
	{
    //1029 double angle  = atan2(state->y - r_ob->y, state->x - r_ob->x) * 180 / M_PI;
		double  angle = state->theta; //PGの(内部更新された後の）角度  1029 追加
	
		if (angle<0)
		{
			angle += 360;
		}

		particle_angle = h_theta ;	//内部更新される前のParticleの角度

		diff_angle = fabs(angle - particle_angle);

		if (diff_angle>180)
		{
			diff_angle = 360 - diff_angle;
		}
     //lik_robot = exp(-0.5 * diff_angle * diff_angle / R2) * robot_weight * r_ob->likelihood;
		lik_robot = exp(-0.5 * diff_angle * diff_angle / R2) ;
	}


  if (ob==NULL)
  {
    return old_weight * lik_robot;
  } else if (r_ob==NULL)
  {
    return old_weight * lik_room;
  } else 
  {
    return old_weight *(lik_room + lik_robot);
  }
	

}*/